
#include "MeterTestController.h"
//
#if(SMTG_OS_WINDOWS)
//#include "../include/stdafx.h"
#endif // 
//
namespace Carlsound
{
	namespace MeterTest 
	{
		//-----------------------------------------------------------------------------
		Steinberg::tresult PLUGIN_API MeterTestController::initialize (FUnknown* context)
		{
			Steinberg::tresult result = EditController::initialize (context);
			if (result == Steinberg::kResultTrue)
			{
				//---Create Parameters------------
				parameters.addParameter
				(
					STR16("Bypass"), // title
					0, // units
					1, // stepCount
					0, // defaultValueNormalized
					Steinberg::Vst::ParameterInfo::kCanAutomate | Steinberg::Vst::ParameterInfo::kIsBypass, // flags
					MeterTestParameters::kParameterBypassId // , // tag
					//0, // unitUD
					//STR16("Bypass") // shortTitle
				);
				//
				parameters.addParameter
				(
					STR16("InputLevel"), // title
					STR16("dB"), // units
					0, // stepCount
					0, // defaultValueNormalized
					Steinberg::Vst::ParameterInfo::kNoFlags, // flags
					MeterTestParameters::kParameterInputLevelFeedback, // tag
					0, // unitID
					STR16("Input Level") // shortTitle
				);
				//
				//---Member Variables------------
				m_InputLevel = 0;
				//
			}
			return Steinberg::kResultTrue;
		}
		//------------------------------------------------------------------------
		Steinberg::tresult PLUGIN_API MeterTestController::setComponentState (Steinberg::IBStream* state)
		{
			// we receive the current state of the component (processor part)
			// we read our parameters and bypass value...
			if (!state)
				return Steinberg::kResultFalse;
			//
			Steinberg::IBStreamer streamer(state, kLittleEndian);
			//
			// read the bypass
			Steinberg::int32 bypassState;
			if (streamer.readInt32(bypassState) == false)
			{
				return Steinberg::kResultFalse;
			}
			setParamNormalized(kParameterBypassId, bypassState ? 1 : 0);
			//
			float savedParam2 = 0.f;
			if (streamer.readFloat(savedParam2) == false)
			{
				return Steinberg::kResultFalse;
			}
			//OutputDebugStringW(L"setComponentState kParamLevel2\n");
			setParamNormalized(MeterTestParameters::kParameterInputLevelFeedback, savedParam2);
			//
			return Steinberg::kResultOk;
		}
		//------------------------------------------------------------------------
		
		Steinberg::tresult PLUGIN_API MeterTestController::setParamNormalized(
			Steinberg::Vst::ParamID tag, 
			Steinberg::Vst::ParamValue value)
		{
			Steinberg::Vst::Parameter* parameter = getParameterObject(tag);
			if (parameter)
			{
				//parameter->setNormalized(value);
				//return kResultTrue;
                //
                switch (tag)
                {
					case kParameterInputLevelFeedback:
					{
						//Steinberg::Vst::ParamValue levelValue2 = value;
						//m_Level2 = value;
						m_InputLevel = value; //parameter->getNormalized();
						//m_LevelColor = m_LevelInput;
						//m_LevelColor = parameter->getNormalized();
						//
                        //IdeConsoleWriteLine(L"setParamNormalized kParameterInputLevel\n");
                        //std::string str = std::to_string(m_InputLevel);
                        //std::wstring strw = std::wstring(str.begin(), str.end());
                        //IdeConsoleWriteLine(L"Input Level = ");
                        //IdeConsoleWriteLine(strw.c_str());
                        //IdeConsoleWriteLine(L"\n");
						//
						//m_GuiVuMeter_InputLevel;
						//
						//if (componentHandler)
						//{
							//componentHandler->beginEdit(kParameterInputLevelFeedback);
							//componentHandler->performEdit(kParameterInputLevelFeedback, value);
							//componentHandler->endEdit(kParameterInputLevelFeedback);
						//}
						//
						#if(SMTG_OS_OSX || SMTG_OS_MACOS)
							if (m_view)
							{
								//m_view->setInputLevelFeedback(m_LevelInput);
							}
						#endif

						#if(SMTG_OS_WINDOWS)
							//wchar buf[2048];
							//swprintf(buf, L"m_InputLevel = %f \n", m_InputLevel);
							//OutputDebugString(buf);
							//
							if (m_view)
							{
								m_view->setInputLevelFeedback(m_InputLevel);
							}
						#endif
						//
						break;
					}
					
					case kParameterBypassId:
					{
						break;
					}
                }
			}
			//return kResultFalse;
			//
			//normalizedParamToPlain(tag, value);
            //
			return Steinberg::Vst::EditController::setParamNormalized(tag, value); //Steinberg::kResultTrue;
		}
		//------------------------------------------------------------------------
		/*
		Steinberg::Vst::ParamValue PLUGIN_API AGainTestController::normalizedParamToPlain (
			Steinberg::Vst::ParamID tag,
			Steinberg::Vst::ParamValue value)
		{
			switch (tag)
			{
				case kParameterInputLevel:
				{
					return value;
					break;
				}
				case kParameterInputLevelFeedback:
				{
					return value;
					break;
				}
				case kParameterThreshold:
				{
					return value;
					break;
				}
				case kParameterColor:
				{
					//OutputDebugStringW(L"normalizedParamToPlain");
					//OutputDebugStringW(L"mParamLevelValue = ");
					//OutputDebugStringW((std::to_wstring(abs(mParamLevelValue*100.0)).c_str()));
					//OutputDebugStringW(L"\n");
					return value;
					break;
				}
				case kParameterColorFeedback:
				{
					return value;
					break;
				}
				
				case kParameterBypassId:
				{
					return value;
					break;
				}
			}
			return value;
		}
		*/
		//------------------------------------------------------------------------
		/*
		Steinberg::Vst::ParamValue AGainTestController::plainParamToNormalized (
			Steinberg::Vst::ParamID tag,
			Steinberg::Vst::ParamValue value)
		{
			switch (tag)
			{
				case kParameterInputLevel:
				{
					return value;
					break;
				}
				case kParameterInputLevelFeedback:
				{
					return value;
					break;
				}
				case kParameterThreshold:
				{
					return value;
					break;
				}
				case kParameterColor:
				{
					//OutputDebugStringW(L"plainParamToNormalized");
					//OutputDebugStringW(L"mParamLevelValue = ");
					//OutputDebugStringW((std::to_wstring(abs(mParamLevelValue*100.0)).c_str()));
					//OutputDebugStringW(L"\n");
					return value;
					break;
				}
				case kParameterColorFeedback:
				{
					return value;
					break;
				}
				case kParameterBypassId:
				{
					return value;
					break;
				}
			}
			return value;
		}
		*/
		//------------------------------------------------------------------------
		void string128copy (
			Steinberg::Vst::TChar *str128, 
			std::string &str)
		{
			for (int i = 0; i < str.length(); i++)
			{
				str128[i] = str[i];
			}
			str128[str.length()] = '\0';
		}
		//------------------------------------------------------------------------
		/*
		Steinberg::tresult AGainTestController::getParamStringByValue (
			Steinberg::Vst::ParamID tag,
			Steinberg::Vst::ParamValue valueNormalized,
			Steinberg::Vst::String128 string)
		{
			std::string valuePlainAscii;
            char* suffix_char = new char;
            *suffix_char = '\0';
            std::string suffix_str(suffix_char);
			//
			switch (tag)
			{
				case kParameterInputLevel:
				{
					float valuePlain = valueNormalized;
					//
					valuePlainAscii = std::to_string(valuePlain) + suffix_str;
					string128copy(string, valuePlainAscii);
					//
					break;
				}
				case kParameterInputLevelFeedback:
				{
					float valuePlain = valueNormalized;
					//
					valuePlainAscii = std::to_string(valuePlain) + suffix_str;
					string128copy(string, valuePlainAscii);
					//
					break;
				}
				case kParameterThreshold:
				{
					float valuePlain = valueNormalized;
					//
					valuePlainAscii = std::to_string(valuePlain) + suffix_str;
					string128copy(string, valuePlainAscii);
					//
					break;
				}
				case kParameterColor:
				{
					float valuePlain = valueNormalized;
					//
					//valuePlainAscii = std::to_string(valuePlain) + '\0';
					if (valuePlain <= 0.05)
					{
						valuePlainAscii = " light green" + suffix_str;
					}
					else if (valuePlain <= 0.1)
					{
						valuePlainAscii = " green" + suffix_str;
					}
					else if (valuePlain <= 0.25)
					{
                        valuePlainAscii = " dark green" + suffix_str;
					}
					else if (valuePlain <= 0.5)
					{
						valuePlainAscii = " yellow" + suffix_str;
					}
					else if (valuePlain <= 0.75)
					{
						valuePlainAscii = " orange" + suffix_str;
					}
					else
					{
						valuePlainAscii = " red" + suffix_str;
					}
					string128copy(string, valuePlainAscii);
					//
					break;
				}
				case kParameterColorFeedback:
				{
					float valuePlain = valueNormalized;
					//
					//valuePlainAscii = std::to_string(valuePlain) + '\0';
					if (valuePlain <= 0.05)
					{
						valuePlainAscii = " light green" + suffix_str;
					}
					else if (valuePlain <= 0.1)
					{
						valuePlainAscii = " green" + suffix_str;
					}
					else if (valuePlain <= 0.25)
					{
						valuePlainAscii = " dark green" + suffix_str;
					}
					else if (valuePlain <= 0.5)
					{
						valuePlainAscii = " yellow" + suffix_str;
					}
					else if (valuePlain <= 0.75)
					{
						valuePlainAscii = " orange" + suffix_str;
					}
					else
					{
						valuePlainAscii = " red" + suffix_str;
					}
					string128copy(string, valuePlainAscii);
					//
					break;
				}
				case kParameterBypassId:
				{
					if (valueNormalized) // on
					{
						valuePlainAscii.clear();
						valuePlainAscii = "On: Bypassed" + suffix_str;
					}
					else // off
					{
						valuePlainAscii.clear();
						valuePlainAscii = "Off: Active" + suffix_str;
					}
					string128copy(string, valuePlainAscii);
					//
					break;
				}
			}
			return Steinberg::kResultOk;
		}
		*/
		//------------------------------------------------------------------------
		/*
		Steinberg::tresult PLUGIN_API AGainTestController::getMidiControllerAssignment(
			Steinberg::int32 busIndex,
			Steinberg::int16 channel,
			Steinberg::Vst::CtrlNumber midiControllerNumber,
			Steinberg::Vst::ParamID& id)
		{
			//throw std::logic_error("The method or operation is not implemented.");
			if (busIndex == 0 && channel == 0)
			{
				id = 0;
				switch (midiControllerNumber)
				{
					//case Steinberg::Vst::ControllerNumbers::kPitchBend: id = kParamMasterTuning; break;
					//case Steinberg::Vst::ControllerNumbers::kCtrlVolume: id = kParamMasterVolume; break;
					//case Steinberg::Vst::ControllerNumbers::kCtrlFilterCutoff: id = kParamFilterFreq; break;
					//case Steinberg::Vst::ControllerNumbers::kCtrlFilterResonance: id = kParamFilterQ; break;
					//
					case Steinberg::Vst::ControllerNumbers::kCtrlGPC1:
					{
						id = kParameterColor;
						break;
					}
					case Steinberg::Vst::ControllerNumbers::kCtrlGPC2:
					{
						id = kParameterBypassId;
						break;
					}
				}
				return id != 0 ? Steinberg::kResultTrue : Steinberg::kResultFalse;
			}
			return Steinberg::kResultFalse;
		}
		*/
		//------------------------------------------------------------------------
		Steinberg::IPlugView* PLUGIN_API MeterTestController::createView (const char* name)
		{
			if (name && strcmp(name, "editor") == 0)
			{
				#if(SMTG_OS_OSX || SMTG_OS_MACOS)
                    m_view = new MeterPlugViewCocoa();
				#endif

				#if(SMTG_OS_WINDOWS)
					m_view = new MeterTestControllerViewWpfHost();
					//
					//m_view->setInputLevelFeedback(0.2);
				#endif

				return m_view;
			}
			return nullptr;
		}
		//------------------------------------------------------------------------
		
	} // namespace AGainTest
} // namespace Carlsound
