#pragma once
//
#include <codecvt>
#include <memory>
#include <string>
#include <iostream>
//
//#include "ideConsoleWriteLine.h"
#include "MeterTestParameters.h"
#include "MeterTestUIDs.h"
//
#include "base/source/fstreamer.h"
#include "pluginterfaces/base/ibstream.h"
#include "pluginterfaces/base/ustring.h"
#include "pluginterfaces/vst/ivstattributes.h"
#include "pluginterfaces/vst/ivstmidicontrollers.h"
#include "pluginterfaces/vst/vsttypes.h"
#include "public.sdk/source/vst/hosting/stringconvert.h"
#include "public.sdk/source/vst/vsteditcontroller.h"
#include "public.sdk/source/vst/hosting/hostclasses.h"
#include "public.sdk/source/vst/hosting/stringconvert.h"
#include "public.sdk/source/vst/vstaudioeffect.h"
#include "public.sdk/source/vst/vsteditcontroller.h"
//
#include "IMeterTestPluginView.h"
//
#if SMTG_OS_WINDOWS
#include <atlconv.h>
#include <tchar.h>
#include "MeterTestControllerViewWpfHost.h"
#endif
//
#if SMTG_OS_MACOS || SMTG_OS_OSX
//#include <Cocoa/Cocoa.h>
//#include "../../Mac_Cocoa/include/meterPlugViewCocoa.h"
#endif
//
namespace Carlsound
{
	namespace MeterTest 
	{
	//-----------------------------------------------------------------------------
		class MeterTestController : public Steinberg::Vst::EditController //,
			//public Steinberg::Vst::IMidiMapping//,
			//public VSTGUI::VST3EditorDelegate
		{
		public:
			OBJ_METHODS(MeterTestController, EditController)
				DEFINE_INTERFACES
				//DEF_INTERFACE(INoteExpressionController)
				//DEF_INTERFACE(IMidiMapping)
				END_DEFINE_INTERFACES(EditController)
				REFCOUNT_METHODS(EditController)
				//------------------------------------------------------------------------
				// create function required for Plug-in factory,
				// it will be called to create new instances of this controller
				//------------------------------------------------------------------------
				static FUnknown* createInstance(void*) {
				return (Steinberg::Vst::IEditController*) new MeterTestController();
			}
			//-----------------------------------------------------------------------------
			//---from IPluginBase--------
			Steinberg::tresult PLUGIN_API initialize(FUnknown* context) SMTG_OVERRIDE;
			//-----------------------------------------------------------------------------
			//---from EditController-----
			Steinberg::tresult PLUGIN_API setComponentState(Steinberg::IBStream* state) SMTG_OVERRIDE;
			//
			Steinberg::tresult PLUGIN_API setParamNormalized(Steinberg::Vst::ParamID tag, Steinberg::Vst::ParamValue value) SMTG_OVERRIDE;
			//-----------------------------------------------------------------------------
			/*
			Steinberg::Vst::ParamValue PLUGIN_API normalizedParamToPlain(
				Steinberg::Vst::ParamID tag,
				Steinberg::Vst::ParamValue value) SMTG_OVERRIDE;
			*/
			//-----------------------------------------------------------------------------
			/*
			Steinberg::Vst::ParamValue PLUGIN_API plainParamToNormalized(
				Steinberg::Vst::ParamID tag,
				Steinberg::Vst::ParamValue value) SMTG_OVERRIDE;
			*/
			//-----------------------------------------------------------------------------
			/*
			Steinberg::tresult PLUGIN_API getParamStringByValue(
				Steinberg::Vst::ParamID tag,
				Steinberg::Vst::ParamValue valueNormalized,
				Steinberg::Vst::String128 string) SMTG_OVERRIDE;
			*/
			//-----------------------------------------------------------------------------
			//---from IMidiMapping---
			/*
			virtual Steinberg::tresult PLUGIN_API getMidiControllerAssignment(
				Steinberg::int32 busIndex,
				Steinberg::int16 channel,
				Steinberg::Vst::CtrlNumber midiControllerNumber,
				Steinberg::Vst::ParamID& id) SMTG_OVERRIDE;
			*/
			//-----------------------------------------------------------------------------
			//---from EditController-----
			Steinberg::IPlugView* PLUGIN_API createView(const char* name) SMTG_OVERRIDE;
			//
			/*
			Steinberg::tresult PLUGIN_API performEdit(Steinberg::Vst::ParamID tag,
													  Steinberg::Vst::ParamValue valueNormalized);
			*/
			//
			//-----------------------------------------------------------------------------
			//---member variables----
		protected:
			Steinberg::Vst::ParamValue m_InputLevel;
			IMeterTestPluginView* m_view;
		};
	} // namespace AGainTest
} // namespace Carlsound
