#include "MeterTestControllerViewWpfHost.h"
//
//extern void* moduleHandle;
//
//
//
namespace Carlsound
{
	namespace MeterTest
	{
		//------------------------------------------------------------------------
		MeterTestControllerViewWpfHost::MeterTestControllerViewWpfHost() :
			m_rect(0, 0, 300, 100),
			m_systemWindow(nullptr),
			m_plugFrame(nullptr),
			m_childWindow(nullptr)
		{
			//LoadMissingDll^ loadmgr = gcnew LoadMissingDll();


			if (SMTG_PLATFORM_64)
			{
				//SetDllDirectoryA("C:\\Program Files\\Common Files\\VST3");
				//System::Reflection::Assembly::LoadFile("C:\\Program Files\\Common Files\\VST3\\Carlsound\\MeterTestWPF\\Meter_WPF_UI_CS_XAML_AnyCPU.dll");
			}
			else
			{
				//SetDllDirectoryA("C:\\Program Files (x86)\\Common Files\\VST3");
				//System::Reflection::Assembly::LoadFile("C:\\Program Files (x86)\\Common Files\\VST3\\Carlsound\\MeterTestWPF\\Meter_WPF_UI_CS_XAML_AnyCPU.dll");
			}
		}

		//------------------------------------------------------------------------
		MeterTestControllerViewWpfHost::MeterTestControllerViewWpfHost(const Steinberg::ViewRect* rect) :
			m_rect(0, 0, 300, 100),
			m_systemWindow(nullptr),
			m_plugFrame(nullptr),
			m_childWindow(nullptr)
		{
			if (rect)
			{
				m_rect = *rect;
			}
			//LoadMissingDll^ loadmgr = gcnew LoadMissingDll();

			//m_hr = CoInitialize(NULL);
			//m_hr = m_UIptr.CreateInstance(__uuidof(Meter_WPF_UI_CS_XAML_AnyCPU::MeterUserControl), NULL, CLSCTX_ALL);

			if (SMTG_PLATFORM_64)
			{
				//SetDllDirectoryA("C:\\Program Files\\Common Files\\VST3");
				LoadLibraryA("C:\\Program Files\\Common Files\\VST3\\build_x64\\Debug\\MeterTestWpfWrapper_x64.dll");
			}
			else
			{
				//SetDllDirectoryA("C:\\Program Files (x86)\\Common Files\\VST3");
				LoadLibraryA("C:\\Program Files (x86)\\Common Files\\VST3\\build_x64\\Debug\\MeterTestWpfWrapper_x86.dll");
			}
		}

		//------------------------------------------------------------------------
		MeterTestControllerViewWpfHost::~MeterTestControllerViewWpfHost()
		{
			//m_UIptr.~_com_ptr_t();
		}

		//------------------------------------------------------------------------
		/** Returns its current frame rectangle. */
		const Steinberg::ViewRect& MeterTestControllerViewWpfHost::getRect() const
		{
			return m_rect;
		}

		//------------------------------------------------------------------------
		/** Sets a new frame rectangle. */
		void MeterTestControllerViewWpfHost::setRect(const Steinberg::ViewRect& r)
		{
			m_rect = r;
		}

		//------------------------------------------------------------------------
		/** Checks if this view is attached to its parent view. */
		bool MeterTestControllerViewWpfHost::isAttached() const
		{
			return m_systemWindow != nullptr;
		}

		//------------------------------------------------------------------------
		// Win32 GUI

		//------------------------------------------------------------------------
		/** Calls when this view will be attached to its parent view. */
		void MeterTestControllerViewWpfHost::attachedToParent()
		{
			// Create the window.

			m_UI = std::make_shared<MeterWpfWrapper>(m_parentWindow);
			//
			m_childWindowIsVisible = TRUE;
		}

		//------------------------------------------------------------------------
		/** Calls when this view will be removed from its parent view. */
		void MeterTestControllerViewWpfHost::removedFromParent()
		{
			//Sciter_UnuseElement(m_rootDomElement);
			//m_UIptr->hide();
			//
			m_systemWindow = nullptr;
		}

		//------------------------------------------------------------------------
		/** Is Platform UI Type supported
				\param type : IDString of \ref platformUIType */
		Steinberg::tresult MeterTestControllerViewWpfHost::isPlatformTypeSupported(Steinberg::FIDString type)
		{
			if (strcmp(type, Steinberg::kPlatformTypeHWND) == 0)
			{
				return Steinberg::kResultTrue;
			}
			else
			{
				return Steinberg::kResultFalse;
			}
		}

		//------------------------------------------------------------------------
		/** The parent window of the view has been created, the (platform) representation of the view
			should now be created as well.
			Note that the parent is owned by the caller and you are not allowed to alter it in any way
			other than adding your own views.
			Note that in this call the Plug-in could call a IPlugFrame::resizeView ()!
			\param parent : platform handle of the parent window or view
			\param type : \ref platformUIType which should be created */
		Steinberg::tresult MeterTestControllerViewWpfHost::attached(void* parent, Steinberg::FIDString type)
		{
			if (strcmp(type, Steinberg::kPlatformTypeHWND) == 0)
			{
				m_systemWindow = parent;
				m_parentWindow = (HWND)parent;
				//
				if (m_plugFrame != nullptr)
				{
					m_plugFrame->resizeView((Steinberg::IPlugView*)this, &m_rect);
				}
				//
				attachedToParent();
				//
				return Steinberg::kResultOk;
			}
			return Steinberg::kResultFalse;
		}

		//------------------------------------------------------------------------
		/** The parent window of the view is about to be destroyed.
			You have to remove all your own views from the parent window or view. */
		Steinberg::tresult MeterTestControllerViewWpfHost::removed()
		{
			removedFromParent();
			//
			return Steinberg::kResultOk;
		}

		//------------------------------------------------------------------------
		/** Handling of mouse wheel. */
		Steinberg::tresult MeterTestControllerViewWpfHost::onWheel(float distance)
		{
			return Steinberg::kResultTrue;
		}

		//------------------------------------------------------------------------
		/** Handling of keyboard events : Key Down.
			\param key : unicode code of key
			\param keyCode : virtual keycode for non ascii keys - see \ref VirtualKeyCodes in keycodes.h
			\param modifiers : any combination of modifiers - see \ref KeyModifier in keycodes.h
			\return kResultTrue if the key is handled, otherwise kResultFalse. \n
					<b> Please note that kResultTrue must only be returned if the key has really been
		   handled. </b> Otherwise key command handling of the host might be blocked! */
		Steinberg::tresult MeterTestControllerViewWpfHost::onKeyDown(Steinberg::char16 key, Steinberg::int16 keyCode, Steinberg::int16 modifiers)
		{
			if (m_childWindowIsVisible)
			{
				this->setInputLevelFeedback(0.25);
			}
			return Steinberg::kResultTrue;
		}

		//------------------------------------------------------------------------
		/** Handling of keyboard events : Key Up.
			\param key : unicode code of key
			\param keyCode : virtual keycode for non ascii keys - see \ref VirtualKeyCodes in keycodes.h
			\param modifiers : any combination of KeyModifier - see \ref KeyModifier in keycodes.h
			\return kResultTrue if the key is handled, otherwise return kResultFalse. */
		Steinberg::tresult MeterTestControllerViewWpfHost::onKeyUp(Steinberg::char16 key, Steinberg::int16 keyCode, Steinberg::int16 modifiers)
		{
			if (m_childWindowIsVisible)
			{
				this->setInputLevelFeedback(0.75);
			}
			return Steinberg::kResultTrue;
		}

		//------------------------------------------------------------------------
		/** Returns the size of the platform representation of the view. */
		Steinberg::tresult MeterTestControllerViewWpfHost::getSize(Steinberg::ViewRect* size)
		{
			if (size)
			{
				*size = m_rect;
				return Steinberg::kResultTrue;
			}
			return Steinberg::kInvalidArgument;
		}

		//------------------------------------------------------------------------
		/** Resizes the platform representation of the view to the given rect. Note that if the Plug-in
		 *	requests a resize (IPlugFrame::resizeView ()) onSize has to be called afterward. */
		Steinberg::tresult MeterTestControllerViewWpfHost::onSize(Steinberg::ViewRect* newSize)
		{
			if ((newSize->right - newSize->left >= 800) && (newSize->bottom - newSize->top >= 450))
			{
				m_rect = *newSize;
				return Steinberg::kResultTrue;
			}
			return Steinberg::kResultFalse;
		}

		//------------------------------------------------------------------------
		/** Focus changed message. */
		Steinberg::tresult MeterTestControllerViewWpfHost::onFocus(Steinberg::TBool state)
		{
			return Steinberg::kResultTrue;
		}

		//------------------------------------------------------------------------
		/** Sets IPlugFrame object to allow the Plug-in to inform the host about resizing. */
		Steinberg::tresult MeterTestControllerViewWpfHost::setFrame(Steinberg::IPlugFrame* frame)
		{
			m_plugFrame = frame;
			if (m_plugFrame != nullptr)
			{
				return Steinberg::kResultTrue;
			}
			return Steinberg::kResultFalse;
		}

		//------------------------------------------------------------------------
		/** Is view sizable by user. */
		Steinberg::tresult MeterTestControllerViewWpfHost::canResize()
		{
			return Steinberg::kResultTrue;
		}

		//------------------------------------------------------------------------
		/** On live resize this is called to check if the view can be resized to the given rect, if not
		 *	adjust the rect to the allowed size. */
		Steinberg::tresult MeterTestControllerViewWpfHost::checkSizeConstraint(Steinberg::ViewRect* rect)
		{
			Steinberg::int32 rectHeight = rect->getHeight();
			Steinberg::int32 rectWidth = rect->getWidth();
			//
			const Steinberg::int32 minHeight = 450;
			const Steinberg::int32 minWidth = 800;
			//
			if ((rectHeight >= minHeight) && (rectWidth >= minWidth))
			{
				return Steinberg::kResultTrue;
			}
			else
			{
				return Steinberg::kResultFalse;
			}
		}

		//------------------------------------------------------------------------
		/**  */
		Steinberg::tresult MeterTestControllerViewWpfHost::setInputLevelFeedback(Steinberg::Vst::ParamValue newLevel)
		{
			//wchar buf[2048];
			//swprintf(buf, L"newLevel = %f\n", newLevel);
			//OutputDebugString(buf);
			//
			//m_UIptr->setInputLevelFeedback(newLevel);
			/*
			if (nullptr != m_rootDomElement)
			{
				const sciter::value val = sciter::value(newLevel);
				SciterCallScriptingFunction(m_rootDomElement, "updateMeter", &val, 1, nullptr);
			}
			*/
			//AGainTestSciterControllerView::SetMeterLevel(newLevel);
			//
			if (m_childWindowIsVisible)
			{
				m_UI->SetLevel(newLevel);
			}
			//
			return Steinberg::kResultTrue;
		}

		//------------------------------------------------------------------------
		/** */
		LRESULT CALLBACK WindowProc(_In_ HWND hwnd, _In_ UINT uMsg, _In_ WPARAM wParam, _In_ LPARAM lParam)
		{
			LRESULT lResult;
			BOOL    bHandled;
			//lResult = SciterProcND(hwnd, uMsg, wParam, lParam, &bHandled);
			//
			return DefWindowProc(hwnd, uMsg, wParam, lParam);
		}

		//------------------------------------------------------------------------
		/**  */
		/*
		Steinberg::tresult PLUGIN_API AGainTestControllerViewWin32SciterHost::setColorFeedback(Steinberg::Vst::ParamValue newColor)
		{
			//m_UIptr->setColorFeedback(newColor);
			//
			return Steinberg::kResultTrue;
		}
		*/

		//------------------------------------------------------------------------
		/** */
		/*
		DWORD WINAPI AGainTestControllerViewWin32SciterHost::S_UiThreadProc(_In_ LPVOID lpParameter)
		{
			return ((AGainTestControllerViewWin32SciterHost*)lpParameter)->UiThreadProc();
		}
		*/

		//------------------------------------------------------------------------
		/** */

		//------------------------------------------------------------------------
		/** */

		// class AGainTestControllerViewWin32SciterHost
	} // namespace AGainTest
} // namespace Carlsound