//------------------------------------------------------------------------
#include "public.sdk/source/main/pluginfactory.h"
//
#include "MeterTestController.h"	// for createInstance
#include "MeterTestProcessor.h"	// for createInstance
#include "MeterTestUIDs.h"	    // for UIDs
#include "MeterTestVersion.h"	// for version and naming
//
#if(SMTG_OS_WINDOWS)
//#include "../include/stdafx.h"
#endif
//
//#define stringSubCategory	"Fx|Analyzer"	// Subcategory for this Plug-in (to be changed if needed, see PlugType in ivstaudioprocessor.h)
//
BEGIN_FACTORY_DEF
(
	stringCompanyName, 
	stringCompanyWeb,	
	stringCompanyEmail
)
	DEF_CLASS2 
	(
		INLINE_UID_FROM_FUID(Carlsound::MeterTest::MeterTestProcessorUID),
		Steinberg::PClassInfo::kManyInstances,	// cardinality  
		kVstAudioEffectClass,	// the component category (do not changed this)
		stringPluginName,		// here the Plug-in name (to be changed)
		Vst::kDistributable,	// means that component and controller could be distributed on different computers
		Steinberg::Vst::PlugType::kFxAnalyzer,		// Subcategory for this Plug-in (to be changed) see PlugType in ivstaudioprocessor.h
		FULL_VERSION_STR,		// Plug-in version (to be changed)
		kVstVersionString,		// the VST 3 SDK version (do not changed this, use always this define)
		Carlsound::MeterTest::MeterTestProcessor::createInstance // function pointer called when this component should be instantiated
	)	
	//
	DEF_CLASS2 
	(
		INLINE_UID_FROM_FUID(Carlsound::MeterTest::MeterTestControllerUID),
		Steinberg::PClassInfo::kManyInstances,  // cardinality   
		kVstComponentControllerClass,// the Controller category (do not changed this)
		stringPluginName "Controller",	// controller name (could be the same than component name)
		0,						// not used here
		"",						// not used here
		FULL_VERSION_STR,		// Plug-in version (to be changed)
		kVstVersionString,		// the VST 3 SDK version (do not changed this, use always this define)
		Carlsound::MeterTest::MeterTestController::createInstance // function pointer called when this component should be instantiated
	)
END_FACTORY

//------------------------------------------------------------------------
//  Module init/exit
//------------------------------------------------------------------------

//------------------------------------------------------------------------
// called after library was loaded
bool InitModule ()
{
	return true;
}

//------------------------------------------------------------------------
// called after library is unloaded
bool DeinitModule ()
{
	return true;
}
