#pragma once
//
//
#if(SMTG_OS_WINDOWS)
//#include "stdafx.h"
#endif //
//
#include "MeterTestController.h"
#include "MeterTestParameters.h"
#include "MeterTestUIDs.h"
//
#include "base/source/fstreamer.h"
#include "pluginterfaces/base/ibstream.h"
#include "pluginterfaces/vst/ivstparameterchanges.h"
#include "pluginterfaces/vst/vsttypes.h"
#include "public.sdk/source/vst/vstaudioeffect.h"
#include "public.sdk/source/vst/vstparameters.h"
#include "public.sdk/source/vst/hosting/hostclasses.h"
#include "public.sdk/source/vst/vstaudioprocessoralgo.h"
//
#define _USE_MATH_DEFINES 
#include <cmath>
#include <cstring>
#include <string.h>
//
namespace Carlsound
{
	namespace MeterTest 
	{
		//-----------------------------------------------------------------------------
		class MeterTestProcessor : public Steinberg::Vst::AudioEffect
		{
		public:
			//------------------------------------------------------------------------
			MeterTestProcessor();
			//------------------------------------------------------------------------
			static FUnknown* createInstance(void*) { return (Steinberg::Vst::IAudioProcessor*) new MeterTestProcessor(); }
			//------------------------------------------------------------------------
			Steinberg::tresult PLUGIN_API initialize (FUnknown* context) SMTG_OVERRIDE;
			//------------------------------------------------------------------------
			Steinberg::tresult PLUGIN_API setBusArrangements (Steinberg::Vst::SpeakerArrangement* inputs, Steinberg::int32 numIns, Steinberg::Vst::SpeakerArrangement* outputs, Steinberg::int32 numOuts) SMTG_OVERRIDE;
			//------------------------------------------------------------------------
			Steinberg::tresult PLUGIN_API setupProcessing(Steinberg::Vst::ProcessSetup& setup) SMTG_OVERRIDE;
			//------------------------------------------------------------------------
			Steinberg::tresult PLUGIN_API setActive (Steinberg::TBool state) SMTG_OVERRIDE;
			//------------------------------------------------------------------------
			Steinberg::tresult canProcessSampleSize (Steinberg::int32 symbolicSampleSize) SMTG_OVERRIDE;
			//------------------------------------------------------------------------
			template <class T> void bufferSampleGain(T inBuffer, T outBuffer, const int sampleLocation);
			//------------------------------------------------------------------------
			Steinberg::tresult PLUGIN_API process (Steinberg::Vst::ProcessData& data) SMTG_OVERRIDE;
			//------------------------------------------------------------------------
			Steinberg::tresult PLUGIN_API setState (Steinberg::IBStream* state) SMTG_OVERRIDE;
			//------------------------------------------------------------------------
			Steinberg::tresult PLUGIN_API getState (Steinberg::IBStream* state) SMTG_OVERRIDE;
			//------------------------------------------------------------------------
		protected:
			bool m_BypassState = false;
			//
			//double m_GainValue[2]{ 0.0, 0.0 };
			//
			Steinberg::Vst::ParamValue m_ParameterInputLevelValue = 0.0;
			Steinberg::Vst::ParamValue m_ParameterThresholdlValue = 0.0;
			Steinberg::Vst::ParamValue m_ParameterColorValue = 0.0;
			//
			Steinberg::int32 m_processMode = 0;
			Steinberg::int32 m_symbolicSampleSize = 2;
			Steinberg::int32 m_maxSamplesPerBlock = 0;
			Steinberg::Vst::SampleRate m_sampleRate = 0;
			//
			Steinberg::int32 m_OutputParameterChangesDataIndex = 0;
			Steinberg::int32 m_OutputParameterValueQueuePointIndex = 0;
			//
			Steinberg::Vst::IParameterChanges* m_OutputParameterChanges = NULL;
			//
			Steinberg::Vst::IParamValueQueue *m_ParameterInputLevelValueQueue = 0;
			Steinberg::Vst::IParamValueQueue* m_ParameterColorValueQueue = 0;
			//
			Steinberg::int32 m_addPointIndex = 0;
			//
            Steinberg::Vst::Event mEvent{ 0 };
		};
		//------------------------------------------------------------------------
	} // namespace AGainTest
} // namespace Carlsound
